# $Id: acoc.spec,v 1.18 2003/06/30 02:10:16 ianmacd Exp $
#
# build with '--with links' to package symlinks
#
# build with '--with per_user' to require ~/.acoc to exist before PATH is
#   modified from /etc/profile.d/

Summary: acoc colours the output of arbitrary command-line programs
Name: acoc
Version: 0.3.0
Release: 1
License: GPL
Group: Applications/Ruby
Source: http://www.caliban.org/files/ruby/%{name}-%{version}.tar.gz
Patch: acoc-per_user.diff
URL: http://www.caliban.org/ruby/
Packager: Ian Macdonald <ian@caliban.org>
BuildRoot: /var/tmp/%{name}-%{version}
BuildArch: noarch
BuildRequires: ruby
Requires: ruby, ruby-term-ansicolor
Obsoletes: rc, rcf
%define links %{?_with_links:1}%{?!_with_links:0}
%define per_user %{?_with_per_user:1}%{?!_with_per_user:0}

%description
acoc is a utility for adding colour to the output of arbitrary command-line
programs. Using a configuration file, regular-expression based pattern-
matching rules and colour sets can be defined for the programs that you use. A
set of default patterns can also be defined, which will be used to colour the
output of programs that have no specific matching rules of their own.

%clean 
rm -rf $RPM_BUILD_ROOT

%prep
%setup -n %{name}-%{version}
%if %{per_user}
%patch -p1
%endif

%install
rm -rf $RPM_BUILD_ROOT
make install ROOT=$RPM_BUILD_ROOT%{_prefix}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
mkdir -p $RPM_BUILD_ROOT%{_prefix}/%{name}/bin
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man{1,5}
install %{name}.shell  $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/%{name}.sh
install %{name}.csh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/%{name}.csh
install %{name}.1 $RPM_BUILD_ROOT%{_mandir}/man1/%{name}.1
install %{name}.conf.5 $RPM_BUILD_ROOT%{_mandir}/man5/%{name}.conf.5
gzip -9 $RPM_BUILD_ROOT%{_mandir}/man1/%{name}.1
gzip -9 $RPM_BUILD_ROOT%{_mandir}/man5/%{name}.conf.5
mv $RPM_BUILD_ROOT%{_prefix}/etc/%{name}.conf $RPM_BUILD_ROOT%{_sysconfdir}/

%if %{links}
cd $RPM_BUILD_ROOT%{_prefix}/%{name}/bin
for i in $(ruby -ne \
  'next unless $_=~/^\[([^\]]+)\]$/; \
   puts $_[1..$_.length-3].split(/\s*,\s*/).each {|x| x.sub!(%r(/.*$), "") }' \
   $RPM_BUILD_ROOT%{_sysconfdir}/acoc.conf); do
  ln -sf ../../bin/%{name} $i
done
cd -
%endif

find $RPM_BUILD_ROOT -type f -o -type l | grep -v /etc/ | \
    ruby -pe 'sub(%r(^'$RPM_BUILD_ROOT'), "")' > %{name}-%{version}-filelist

%files -f %{name}-%{version}-filelist
%defattr(-,root,root)
%doc BUGS Changelog COPYING %{name}*.html %{name}.conf.rd README INSTALL TODO
%config %{_sysconfdir}/%{name}.conf
%config %{_sysconfdir}/profile.d/%{name}.*
%dir %{_prefix}/%{name}
%dir %{_prefix}/%{name}/bin

%changelog
* Sun Jun 29 2003 Ian Macdonald <ian@caliban.org> 0.3.0-1
- new program flag /p requests allocation of a pseudo-terminal through which
  to run the target program (requires optional Ruby/TPty library)
- merely exec() the program if there *is* a configuration stanza, but it
  contains no rules
- code clean-up
- configure ls to get a pseudo-terminal

* Wed Jun 25 2003 Ian Macdonald <ian@caliban.org> 0.2.6-1
- 0.2.6
- new program flag /r removes all previous matching rules for given program
- building with '--with per_user' patches the files that go into
  /etc/profile.d, so that ~/.acoc must exist before the path will be modified

* Sat Jun 21 2003 Ian Macdonald <ian@caliban.org> 0.2.5-1
- 0.2.5
- by default, no colouring will take place if stdout is not a tty
- new program flag /t allows colouring to take place even when stdout
  is not a tty
- add new BUGS file

* Fri Jun 20 2003 Ian Macdonald <ian@caliban.org> 0.2.1-1
- 0.2.1
- new config sections for tcpdump, ldd, nm, strace, ltrace, id and ls
- diff config now also applies to rcsdiff
- make config now also applies to gmake
- tarball now includes Term::ANSIColor for lazy people

* Wed Jun 11 2003 Ian Macdonald <ian@caliban.org> 0.2.0-1
- 0.2.0
- catch SIGPIPE while printing
- error message if we're called on a non-existent program should go to
  stderr, not stdout
- program flags are now cumulative with each stanza for programs that have
  multiple stanzas
- diff rules now handle standard and context format output
- rpmbuild rules broken out into gcc and make rules

* Sat Jun  7 2003 Ian Macdonald <ian@caliban.org> 0.1.0-1
- 0.1.0, first public release
- program renamed acoc
- full documentation included

* Fri Jun  6 2003 Ian Macdonald <ian@caliban.org> 0.1.0pre3-1
- 0.1.0pre3-1
- program renamed from rc to rcf
- config rules for df, route and ifconfig

* Thu Jun  5 2003 Ian Macdonald <ian@caliban.org> 0.1.0pre2-1
- 0.1.0pre2-1
- multiple colours can be specified for a single match component,
  e.g. bold+green
- add more rules to rcf.conf
- improve documentation
- building with '--with links' populates %%{_prefix}/%%{name}/bin with
  links to all programs for which rcf.conf contains configurations

* Tue Jun  3 2003 Ian Macdonald <ian@caliban.org> 0.1.0pre1-1
- 0.1.0pre1-1
